%% About File
%--------------------------------------------------------------------------
% filename     : figure2.m
% author       : Paul Chinwang Yoo
% date created : 12/14/2016
% cd /mq/home/m1pcy00/RA_Work/Taisuke_Nakata/FiscalMultiplier/Fiscal_Multipliers_PostFED/NL_2SMS_TShock
% figure2.m
%--------------------------------------------------------------------------

%% Main Code
clear all
close all
clc

file_names   = {'irf_G_MODEL_'};
shock_files  = {'delshock_NITR_corr_FM_NL','delshock_gshock_NITR_corr_FM_NL'};
irf_types    = {'_IRF8Q'};
expect_files = {'e_'};
file_type    = {'.dat'};

cBET     = 0.9925d0;
cCHIc    = 1d0;
cCHIn    = 0.2d0;
cTHETA   = 5d0;
cPHI     = 160d0;
cPHIpi   = 3d0;
cPHIy    = 1d0;
cGAM     = 0.2d0;
pLR      = 0.825;

cPIBAR = 1d0;
cRBAR  = cPIBAR / cBET;
cCBAR  = ( ( cTHETA - 1d0 )*( 1d0 - cGAM )^( cCHIn ) / cTHETA )^(1d0/(cCHIn+cCHIc));
cYBAR  = cCBAR/(1d0-cGAM);
cGBAR  = cGAM*cCBAR/(1d0-cGAM);
cWBAR  = cYBAR^(cCHIn)*cCBAR^(cCHIc);

ylims1  = [-35 7.5;-40 7.5;-11 1.5;0 1.5];
ylims2  = [-.75 5;-1.45 0;-.15 .75;1 2.5];
ylimse1 = [0 1.25;-11 0;1 10];
ylimse2 = [1 2.5;0 0.725;0.8 1.625];

% Create the IRF non-expect matrix
for i = 1:length(shock_files)
    for j = 1:length(irf_types)
        disp(char(strcat(file_names(1),shock_files(i),irf_types(j),file_type(1))));
        mat = dlmread(char(strcat(file_names(1),shock_files(i),irf_types(j),file_type(1))));
%         mat = mat(1:100,:);
        IRF_ne(:,:,i,j) = mat;
    end
end

period_col = 1;
cLz_col    = 2;
del_col_ne = 3;
g_col_ne   = 4;
y_col_ne   = 5;
c_col_ne   = 6;
pi_col_ne  = 7;
r_col_ne   = 8;
rsh_col_ne = 9;
w_col_ne   = 10;
rhoR_col   = 11;

vars = {'$Y_{t}$','$C_{t}$','$\Pi_{t}$','$R_{t}$','$R_{t}^{*}$'};
cols = [y_col_ne c_col_ne pi_col_ne r_col_ne rsh_col_ne];
rhoR_vals = unique(IRF_ne(:,rhoR_col,1,1));
time      = (1:1:40)';
ylims = [-10 5;-20 10;-10 5;0 4;-60 20];

fig1 = figure(1);
for i = 1:length(rhoR_vals')
    for j = 1:length(vars)
        subplot(length(vars)+1,length(rhoR_vals)+1,(j-1)*(length(rhoR_vals)+1) + i)
        grid off
        box on
        hold on
%         plot(time,IRF_ne(IRF_ne(:,rhoR_col,1,1) == rhoR_vals(i),cols(j),1,1),'k',time,IRF_ne(IRF_ne(:,rhoR_col,2,1) == rhoR_vals(i),cols(j),2,1),'r','LineWidth',2)
        plot(time,IRF_ne(IRF_ne(:,rhoR_col,1,1) == rhoR_vals(i),cols(j),1,1),'k',time,IRF_ne(IRF_ne(:,rhoR_col,2,1) == rhoR_vals(i),cols(j),2,1),'r--','LineWidth',2)
        if i == 1
            if j == 1
                ll = legend('w/o G','w/ G','interpreter','latex','FontSize',15);
                set(ll,'Location','SouthEast')
            end
        end
        ylabel(vars(j),'interpreter','latex','FontSize',15)
        if j == 1
            title(strcat('$\rho_{r} = ',num2str(rhoR_vals(i)),'$'),'interpreter','latex','FontSize',15)
        end

        set(gca,'XLim',[0 20],'XTick',(0:5:20),'YLim',ylims(j,:),'FontSize',10);
    end
end
set(fig1,'PaperOrientation','Landscape');
set(fig1,'PaperPosition',[0 0 11 8.5]);
% print(fig1,'-depsc','IRF8Q.eps');
% print(fig1,'-dpdf','IRF8Q.pdf');
print(fig1,'-depsc','IRF8Q_colorless.eps');
print(fig1,'-dpdf','IRF8Q_colorless.pdf');