%% About File
%--------------------------------------------------------------------------
% filename     : figure3.m
% author       : Paul Chinwang Yoo
% date created : 12/14/2016
% cd /mq/home/m1pcy00/RA_Work/Taisuke_Nakata/FiscalMultiplier/Fiscal_Multipliers_PostFED/NL_2SMS_TShock
% figure3.m
%--------------------------------------------------------------------------

%% Main Code
clear all
close all
clc

% First file (Shock Duration vs. ZLB Duration)
ShockDur_ZLB = dlmread('cRHOr_ShockDur_ZLBD.dat');

% Second file (cRHOr vs. EZLBD)
EZLBD_mat = dlmread('cRHOr_EZLBD.dat');

rhoR_vals = EZLBD_mat(:,1);
EZLBD     = EZLBD_mat(:,2);
shock_dur = unique(ShockDur_ZLB(:,2));

fig1 = figure(1);
grid off
hold on
box on
for i = 1:size(shock_dur,1)
    p(i) = plot(rhoR_vals,ShockDur_ZLB(ShockDur_ZLB(:,2) == shock_dur(i,1),3),'k','LineWidth',1);
end
pp = plot(rhoR_vals,EZLBD,'k','LineWidth',3);
L = legend([p(1),pp],'ZLB Duration by Shock Duration','Expected ZLB Duration');
set(L,'FontSize',20,'Location','NorthWest')
set(gca,'XLim',[0 1],'XTick',(0:0.2:1),'YLim',[0 25],'FontSize',20)
set(fig1,'PaperOrientation','Landscape');
set(fig1,'PaperPosition',[0 0 11 8.5]);
print(fig1,'-depsc','EZLBD.eps');
print(fig1,'-dpdf','EZLBD.pdf');