%% About File
%--------------------------------------------------------------------------
% filename     : PVGM.m
% author       : Paul Chinwang Yoo
% date created : 4/22/2016
% cd /mq/home/m1pcy00/RA_Work/Taisuke_Nakata/FiscalMultiplier/Fiscal_Multipliers_PostFED/NL_2SMS_TShock
% PVGM.m
%--------------------------------------------------------------------------

%% Main Code
clear all
close all
clc

pvgm_files = {'1Qpvgm','4Qpvgm','20Qpvgm','40Qpvgm'};
quarters   = [1 4 20 40];

rhor_col = 1;
y_col = 2;
g_col = 3;

cBET     = 0.9925d0; 
cCHIc    = 1d0; 
cCHIn    = 0.2d0;    
cTHETA   = 5d0;   
cPHI     = 160d0;   
cPHIpi   = 3d0;
cPHIy    = 1d0;
cGAM     = 0.2d0;
cZETA    = 0.1d0;

cPIBAR  = 1d0;
cRBAR   = cPIBAR / cBET;
cWBAR   = (cTHETA - 1d0)/cTHETA;
cYBAR   = (cWBAR/(((1d0-cZETA)*(1d0-cPHI/2d0*((cPIBAR-1d0)^2d0)-cGAM))^cCHIc))^(1d0/(cCHIc+cCHIn));
cCBAR   = cYBAR*(1d0-cPHI/2d0*((cPIBAR-1d0)^2d0)-cGAM);
cLAMBAR = ((1d0-cZETA)*cCBAR)^(-cCHIc);
cGBAR   = cGAM*cYBAR;

for i = 1:40
    if i == 1
        e_y_ss(i) = cYBAR;
        e_g_ss(i) = cGBAR;
    else
        e_y_ss(i) = cBET*e_y_ss(i-1);
        e_g_ss(i) = cBET*e_g_ss(i-1);
    end
end

at_ZLB   = zeros(2,4);
away_ZLB = zeros(2,4);

for i = 1:length(pvgm_files),
    dg_shock = dlmread(char(strcat('irf_G_MODEL_delshock_gshock_NITR_e_corr_FM_NL_',pvgm_files(i),'.dat')));
    d_shock  = dlmread(char(strcat('irf_G_MODEL_delshock_NITR_e_corr_FM_NL_',pvgm_files(i),'.dat')));
    
    rhor_vals = dg_shock(:,rhor_col);
    
    y_dg_vals = dg_shock(:,y_col);
    y_d_vals  = d_shock(:,y_col);
    
    g_dg_vals = dg_shock(:,g_col);
    g_d_vals  = d_shock(:,g_col);
    
    at_ZLB(:,i) = (y_dg_vals - y_d_vals)./(g_dg_vals - g_d_vals);
end

for i = 1:length(pvgm_files),
    g_shock = dlmread(char(strcat('irf_G_MODEL_gshock_NITR_e_corr_FM_NL_',pvgm_files(i),'.dat')));
    
    rhor_vals = g_shock(:,rhor_col);
    
    y_g_vals  = g_shock(:,y_col) - sum(e_y_ss(1:quarters(i)));
    
    g_g_vals  = g_shock(:,g_col) - sum(e_g_ss(1:quarters(i)));
    
    away_ZLB(:,i) = (y_g_vals)./(g_g_vals);
end

save('PVGM.mat','at_ZLB','away_ZLB')